//--------------------------------------------------------------
// File     : xmc2go_ub_led.c
// Datum    : 19.04.2014
// Version  : 1.0
// Autor    : UB
// EMail    : mc-4u(@)t-online.de
// Web      : www.mikrocontroller-4u.de
// CPU      : XMC1100-0064 (XMC2GO)
// IDE      : KEIL uVision 5.10
// ARMCC    : 5.04
// Module   : GPIO
// Funktion : LED Funktionen
//
// Hinweise : LED1 = P1.0
//            LED2 = P1.1
//--------------------------------------------------------------


/*******************************************************************************
 Copyright (c) 2013, Infineon Technologies AG                                 **
 All rights reserved.                                                         **
                                                                              **
 Redistribution and use in source and binary forms, with or without           **
 modification,are permitted provided that the following conditions are met:   **
                                                                              **
 *Redistributions of source code must retain the above copyright notice,      **
 this list of conditions and the following disclaimer.                        **
 *Redistributions in binary form must reproduce the above copyright notice,   **
 this list of conditions and the following disclaimer in the documentation    **
 and/or other materials provided with the distribution.                       **
 *Neither the name of the copyright holders nor the names of its contributors **
 may be used to endorse or promote products derived from this software without**
 specific prior written permission.                                           **
                                                                              **
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"  **
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    **
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   **
 ARE  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE   **
 LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR         **
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF         **
 SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS    **
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN      **
 CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)       **
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE   **
 POSSIBILITY OF SUCH DAMAGE.                                                  **
                                                                              **
 To improve the quality of the software, users are encouraged to share        **
 modifications, enhancements or bug fixes with Infineon Technologies AG       **
 dave@infineon.com).                                                          **
*******************************************************************************/


//--------------------------------------------------------------
// Includes
//--------------------------------------------------------------
#include "xmc2go_ub_led.h"


//--------------------------------------------------------------
// Init aller LEDs
//--------------------------------------------------------------
void XMC2GO_Led_Init(void)
{
  // GPIO config
  P1_0_set_mode(OUTPUT_PP_GP);
  P1_1_set_mode(OUTPUT_PP_GP);

  XMC2GO_Led_Off(LED1);
  XMC2GO_Led_Off(LED2);
}

//--------------------------------------------------------------
// LED ausschalten
//--------------------------------------------------------------
void XMC2GO_Led_Off(LED_NAME_t led_name)
{
  if(led_name==LED1) {
    P1_0_reset();
  }
  if(led_name==LED2) {
    P1_1_reset();
  }  
}

//--------------------------------------------------------------
// LED einschalten
//--------------------------------------------------------------
void XMC2GO_Led_On(LED_NAME_t led_name)
{
  if(led_name==LED1) {
    P1_0_set();
  }
  if(led_name==LED2) {
    P1_1_set();
  }
}

//--------------------------------------------------------------
// LED toggeln
//--------------------------------------------------------------
void XMC2GO_Led_Toggle(LED_NAME_t led_name)
{
  if(led_name==LED1) {
    P1_0_toggle();
  }
  if(led_name==LED2) {
    P1_1_toggle();
  }
}
